﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using FreeSql;
using FreeSql.DataAnnotations;

namespace JXCMS.CMS.Movie.Entity
{
    public class MovieEntity : BaseEntity<MovieEntity, int>
    {
        public string Name { get; set; }

        public string Pic { get; set; }

        public int ClassifyId { get; set; }

        public string Lang { get; set; }

        public string Area { get; set; }

        public string Year { get; set; }

        public int DirectorId { get; set; }
        
        public DateTime LastUpdate { get; set; }

        public bool IsEnable { get; set; } = true;

        [StringLength(-1)]
        public string Des { get; set; }

        [Navigate("DirectorId")]
        public virtual DirectorEntity DirectorEntity { get; set; }
        
        [Navigate("ClassifyId")]
        public virtual ClassifyEntity ClassifyEntity { get; set; }

        [Navigate(ManyToMany = typeof(MovieActorEntity))]
        public virtual List<ActorEntity> ActorEntities { get; set; }

        [Navigate("Id")]
        public virtual List<MovieListEntity> MovieListEntities { get; set; }
    }
}